"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
Copyright 2023 LiveKit, Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
"""
import builtins
import collections.abc
import google.protobuf.descriptor
import google.protobuf.internal.containers
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
from . import livekit_models_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

class _IngressInput:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _IngressInputEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_IngressInput.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    RTMP_INPUT: _IngressInput.ValueType  # 0
    WHIP_INPUT: _IngressInput.ValueType  # 1
    URL_INPUT: _IngressInput.ValueType  # 2
    """Pull from the provided URL. Only HTTP url are supported, serving either a single media file or a HLS stream"""

class IngressInput(_IngressInput, metaclass=_IngressInputEnumTypeWrapper): ...

RTMP_INPUT: IngressInput.ValueType  # 0
WHIP_INPUT: IngressInput.ValueType  # 1
URL_INPUT: IngressInput.ValueType  # 2
"""Pull from the provided URL. Only HTTP url are supported, serving either a single media file or a HLS stream"""
global___IngressInput = IngressInput

class _IngressAudioEncodingPreset:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _IngressAudioEncodingPresetEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_IngressAudioEncodingPreset.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    OPUS_STEREO_96KBPS: _IngressAudioEncodingPreset.ValueType  # 0
    """OPUS, 2 channels, 96kbps"""
    OPUS_MONO_64KBS: _IngressAudioEncodingPreset.ValueType  # 1
    """OPUS, 1 channel, 64kbps"""

class IngressAudioEncodingPreset(_IngressAudioEncodingPreset, metaclass=_IngressAudioEncodingPresetEnumTypeWrapper): ...

OPUS_STEREO_96KBPS: IngressAudioEncodingPreset.ValueType  # 0
"""OPUS, 2 channels, 96kbps"""
OPUS_MONO_64KBS: IngressAudioEncodingPreset.ValueType  # 1
"""OPUS, 1 channel, 64kbps"""
global___IngressAudioEncodingPreset = IngressAudioEncodingPreset

class _IngressVideoEncodingPreset:
    ValueType = typing.NewType("ValueType", builtins.int)
    V: typing_extensions.TypeAlias = ValueType

class _IngressVideoEncodingPresetEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[_IngressVideoEncodingPreset.ValueType], builtins.type):
    DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
    H264_720P_30FPS_3_LAYERS: _IngressVideoEncodingPreset.ValueType  # 0
    """1280x720,  30fps, 1900kbps main layer, 3 layers total"""
    H264_1080P_30FPS_3_LAYERS: _IngressVideoEncodingPreset.ValueType  # 1
    """1980x1080, 30fps, 3500kbps main layer, 3 layers total"""
    H264_540P_25FPS_2_LAYERS: _IngressVideoEncodingPreset.ValueType  # 2
    """ 960x540,  25fps, 1000kbps  main layer, 2 layers total"""
    H264_720P_30FPS_1_LAYER: _IngressVideoEncodingPreset.ValueType  # 3
    """1280x720,  30fps, 1900kbps, no simulcast"""
    H264_1080P_30FPS_1_LAYER: _IngressVideoEncodingPreset.ValueType  # 4
    """1980x1080, 30fps, 3500kbps, no simulcast"""
    H264_720P_30FPS_3_LAYERS_HIGH_MOTION: _IngressVideoEncodingPreset.ValueType  # 5
    """1280x720,  30fps, 2500kbps main layer, 3 layers total, higher bitrate for high motion, harder to encode content"""
    H264_1080P_30FPS_3_LAYERS_HIGH_MOTION: _IngressVideoEncodingPreset.ValueType  # 6
    """1980x1080, 30fps, 4500kbps main layer, 3 layers total, higher bitrate for high motion, harder to encode content"""
    H264_540P_25FPS_2_LAYERS_HIGH_MOTION: _IngressVideoEncodingPreset.ValueType  # 7
    """ 960x540,  25fps, 1300kbps  main layer, 2 layers total, higher bitrate for high motion, harder to encode content"""
    H264_720P_30FPS_1_LAYER_HIGH_MOTION: _IngressVideoEncodingPreset.ValueType  # 8
    """1280x720,  30fps, 2500kbps, no simulcast, higher bitrate for high motion, harder to encode content"""
    H264_1080P_30FPS_1_LAYER_HIGH_MOTION: _IngressVideoEncodingPreset.ValueType  # 9
    """1980x1080, 30fps, 4500kbps, no simulcast, higher bitrate for high motion, harder to encode content"""

class IngressVideoEncodingPreset(_IngressVideoEncodingPreset, metaclass=_IngressVideoEncodingPresetEnumTypeWrapper): ...

H264_720P_30FPS_3_LAYERS: IngressVideoEncodingPreset.ValueType  # 0
"""1280x720,  30fps, 1900kbps main layer, 3 layers total"""
H264_1080P_30FPS_3_LAYERS: IngressVideoEncodingPreset.ValueType  # 1
"""1980x1080, 30fps, 3500kbps main layer, 3 layers total"""
H264_540P_25FPS_2_LAYERS: IngressVideoEncodingPreset.ValueType  # 2
""" 960x540,  25fps, 1000kbps  main layer, 2 layers total"""
H264_720P_30FPS_1_LAYER: IngressVideoEncodingPreset.ValueType  # 3
"""1280x720,  30fps, 1900kbps, no simulcast"""
H264_1080P_30FPS_1_LAYER: IngressVideoEncodingPreset.ValueType  # 4
"""1980x1080, 30fps, 3500kbps, no simulcast"""
H264_720P_30FPS_3_LAYERS_HIGH_MOTION: IngressVideoEncodingPreset.ValueType  # 5
"""1280x720,  30fps, 2500kbps main layer, 3 layers total, higher bitrate for high motion, harder to encode content"""
H264_1080P_30FPS_3_LAYERS_HIGH_MOTION: IngressVideoEncodingPreset.ValueType  # 6
"""1980x1080, 30fps, 4500kbps main layer, 3 layers total, higher bitrate for high motion, harder to encode content"""
H264_540P_25FPS_2_LAYERS_HIGH_MOTION: IngressVideoEncodingPreset.ValueType  # 7
""" 960x540,  25fps, 1300kbps  main layer, 2 layers total, higher bitrate for high motion, harder to encode content"""
H264_720P_30FPS_1_LAYER_HIGH_MOTION: IngressVideoEncodingPreset.ValueType  # 8
"""1280x720,  30fps, 2500kbps, no simulcast, higher bitrate for high motion, harder to encode content"""
H264_1080P_30FPS_1_LAYER_HIGH_MOTION: IngressVideoEncodingPreset.ValueType  # 9
"""1980x1080, 30fps, 4500kbps, no simulcast, higher bitrate for high motion, harder to encode content"""
global___IngressVideoEncodingPreset = IngressVideoEncodingPreset

@typing_extensions.final
class CreateIngressRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INPUT_TYPE_FIELD_NUMBER: builtins.int
    URL_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    ROOM_NAME_FIELD_NUMBER: builtins.int
    PARTICIPANT_IDENTITY_FIELD_NUMBER: builtins.int
    PARTICIPANT_NAME_FIELD_NUMBER: builtins.int
    BYPASS_TRANSCODING_FIELD_NUMBER: builtins.int
    AUDIO_FIELD_NUMBER: builtins.int
    VIDEO_FIELD_NUMBER: builtins.int
    input_type: global___IngressInput.ValueType
    url: builtins.str
    """Where to pull media from, only for URL input type"""
    name: builtins.str
    """User provided identifier for the ingress"""
    room_name: builtins.str
    """room to publish to"""
    participant_identity: builtins.str
    """publish as participant"""
    participant_name: builtins.str
    """name of publishing participant (used for display only)"""
    bypass_transcoding: builtins.bool
    """whether to pass through the incoming media without transcoding, only compatible with some input types"""
    @property
    def audio(self) -> global___IngressAudioOptions: ...
    @property
    def video(self) -> global___IngressVideoOptions: ...
    def __init__(
        self,
        *,
        input_type: global___IngressInput.ValueType = ...,
        url: builtins.str = ...,
        name: builtins.str = ...,
        room_name: builtins.str = ...,
        participant_identity: builtins.str = ...,
        participant_name: builtins.str = ...,
        bypass_transcoding: builtins.bool = ...,
        audio: global___IngressAudioOptions | None = ...,
        video: global___IngressVideoOptions | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["audio", b"audio", "video", b"video"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["audio", b"audio", "bypass_transcoding", b"bypass_transcoding", "input_type", b"input_type", "name", b"name", "participant_identity", b"participant_identity", "participant_name", b"participant_name", "room_name", b"room_name", "url", b"url", "video", b"video"]) -> None: ...

global___CreateIngressRequest = CreateIngressRequest

@typing_extensions.final
class IngressAudioOptions(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    SOURCE_FIELD_NUMBER: builtins.int
    PRESET_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    name: builtins.str
    source: livekit_models_pb2.TrackSource.ValueType
    preset: global___IngressAudioEncodingPreset.ValueType
    @property
    def options(self) -> global___IngressAudioEncodingOptions: ...
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        source: livekit_models_pb2.TrackSource.ValueType = ...,
        preset: global___IngressAudioEncodingPreset.ValueType = ...,
        options: global___IngressAudioEncodingOptions | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["encoding_options", b"encoding_options", "options", b"options", "preset", b"preset"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["encoding_options", b"encoding_options", "name", b"name", "options", b"options", "preset", b"preset", "source", b"source"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["encoding_options", b"encoding_options"]) -> typing_extensions.Literal["preset", "options"] | None: ...

global___IngressAudioOptions = IngressAudioOptions

@typing_extensions.final
class IngressVideoOptions(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    NAME_FIELD_NUMBER: builtins.int
    SOURCE_FIELD_NUMBER: builtins.int
    PRESET_FIELD_NUMBER: builtins.int
    OPTIONS_FIELD_NUMBER: builtins.int
    name: builtins.str
    source: livekit_models_pb2.TrackSource.ValueType
    preset: global___IngressVideoEncodingPreset.ValueType
    @property
    def options(self) -> global___IngressVideoEncodingOptions: ...
    def __init__(
        self,
        *,
        name: builtins.str = ...,
        source: livekit_models_pb2.TrackSource.ValueType = ...,
        preset: global___IngressVideoEncodingPreset.ValueType = ...,
        options: global___IngressVideoEncodingOptions | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["encoding_options", b"encoding_options", "options", b"options", "preset", b"preset"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["encoding_options", b"encoding_options", "name", b"name", "options", b"options", "preset", b"preset", "source", b"source"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["encoding_options", b"encoding_options"]) -> typing_extensions.Literal["preset", "options"] | None: ...

global___IngressVideoOptions = IngressVideoOptions

@typing_extensions.final
class IngressAudioEncodingOptions(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    AUDIO_CODEC_FIELD_NUMBER: builtins.int
    BITRATE_FIELD_NUMBER: builtins.int
    DISABLE_DTX_FIELD_NUMBER: builtins.int
    CHANNELS_FIELD_NUMBER: builtins.int
    audio_codec: livekit_models_pb2.AudioCodec.ValueType
    """desired audio codec to publish to room"""
    bitrate: builtins.int
    disable_dtx: builtins.bool
    channels: builtins.int
    def __init__(
        self,
        *,
        audio_codec: livekit_models_pb2.AudioCodec.ValueType = ...,
        bitrate: builtins.int = ...,
        disable_dtx: builtins.bool = ...,
        channels: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["audio_codec", b"audio_codec", "bitrate", b"bitrate", "channels", b"channels", "disable_dtx", b"disable_dtx"]) -> None: ...

global___IngressAudioEncodingOptions = IngressAudioEncodingOptions

@typing_extensions.final
class IngressVideoEncodingOptions(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    VIDEO_CODEC_FIELD_NUMBER: builtins.int
    FRAME_RATE_FIELD_NUMBER: builtins.int
    LAYERS_FIELD_NUMBER: builtins.int
    video_codec: livekit_models_pb2.VideoCodec.ValueType
    """desired codec to publish to room"""
    frame_rate: builtins.float
    @property
    def layers(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[livekit_models_pb2.VideoLayer]:
        """simulcast layers to publish, when empty, should usually be set to layers at 1/2 and 1/4 of the dimensions"""
    def __init__(
        self,
        *,
        video_codec: livekit_models_pb2.VideoCodec.ValueType = ...,
        frame_rate: builtins.float = ...,
        layers: collections.abc.Iterable[livekit_models_pb2.VideoLayer] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["frame_rate", b"frame_rate", "layers", b"layers", "video_codec", b"video_codec"]) -> None: ...

global___IngressVideoEncodingOptions = IngressVideoEncodingOptions

@typing_extensions.final
class IngressInfo(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INGRESS_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    STREAM_KEY_FIELD_NUMBER: builtins.int
    URL_FIELD_NUMBER: builtins.int
    INPUT_TYPE_FIELD_NUMBER: builtins.int
    BYPASS_TRANSCODING_FIELD_NUMBER: builtins.int
    AUDIO_FIELD_NUMBER: builtins.int
    VIDEO_FIELD_NUMBER: builtins.int
    ROOM_NAME_FIELD_NUMBER: builtins.int
    PARTICIPANT_IDENTITY_FIELD_NUMBER: builtins.int
    PARTICIPANT_NAME_FIELD_NUMBER: builtins.int
    REUSABLE_FIELD_NUMBER: builtins.int
    STATE_FIELD_NUMBER: builtins.int
    ingress_id: builtins.str
    name: builtins.str
    stream_key: builtins.str
    url: builtins.str
    """URL to point the encoder to for push (RTMP, WHIP), or location to pull media from for pull (URL)"""
    input_type: global___IngressInput.ValueType
    """for RTMP input, it'll be a rtmp:// URL
    for FILE input, it'll be a http:// URL
    for SRT input, it'll be a srt:// URL
    """
    bypass_transcoding: builtins.bool
    @property
    def audio(self) -> global___IngressAudioOptions: ...
    @property
    def video(self) -> global___IngressVideoOptions: ...
    room_name: builtins.str
    participant_identity: builtins.str
    participant_name: builtins.str
    reusable: builtins.bool
    @property
    def state(self) -> global___IngressState:
        """Description of error/stream non compliance and debug info for publisher otherwise (received bitrate, resolution, bandwidth)"""
    def __init__(
        self,
        *,
        ingress_id: builtins.str = ...,
        name: builtins.str = ...,
        stream_key: builtins.str = ...,
        url: builtins.str = ...,
        input_type: global___IngressInput.ValueType = ...,
        bypass_transcoding: builtins.bool = ...,
        audio: global___IngressAudioOptions | None = ...,
        video: global___IngressVideoOptions | None = ...,
        room_name: builtins.str = ...,
        participant_identity: builtins.str = ...,
        participant_name: builtins.str = ...,
        reusable: builtins.bool = ...,
        state: global___IngressState | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["audio", b"audio", "state", b"state", "video", b"video"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["audio", b"audio", "bypass_transcoding", b"bypass_transcoding", "ingress_id", b"ingress_id", "input_type", b"input_type", "name", b"name", "participant_identity", b"participant_identity", "participant_name", b"participant_name", "reusable", b"reusable", "room_name", b"room_name", "state", b"state", "stream_key", b"stream_key", "url", b"url", "video", b"video"]) -> None: ...

global___IngressInfo = IngressInfo

@typing_extensions.final
class IngressState(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _Status:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _StatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[IngressState._Status.ValueType], builtins.type):  # noqa: F821
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        ENDPOINT_INACTIVE: IngressState._Status.ValueType  # 0
        ENDPOINT_BUFFERING: IngressState._Status.ValueType  # 1
        ENDPOINT_PUBLISHING: IngressState._Status.ValueType  # 2
        ENDPOINT_ERROR: IngressState._Status.ValueType  # 3
        ENDPOINT_COMPLETE: IngressState._Status.ValueType  # 4

    class Status(_Status, metaclass=_StatusEnumTypeWrapper): ...
    ENDPOINT_INACTIVE: IngressState.Status.ValueType  # 0
    ENDPOINT_BUFFERING: IngressState.Status.ValueType  # 1
    ENDPOINT_PUBLISHING: IngressState.Status.ValueType  # 2
    ENDPOINT_ERROR: IngressState.Status.ValueType  # 3
    ENDPOINT_COMPLETE: IngressState.Status.ValueType  # 4

    STATUS_FIELD_NUMBER: builtins.int
    ERROR_FIELD_NUMBER: builtins.int
    VIDEO_FIELD_NUMBER: builtins.int
    AUDIO_FIELD_NUMBER: builtins.int
    ROOM_ID_FIELD_NUMBER: builtins.int
    STARTED_AT_FIELD_NUMBER: builtins.int
    ENDED_AT_FIELD_NUMBER: builtins.int
    RESOURCE_ID_FIELD_NUMBER: builtins.int
    TRACKS_FIELD_NUMBER: builtins.int
    status: global___IngressState.Status.ValueType
    error: builtins.str
    """Error/non compliance description if any"""
    @property
    def video(self) -> global___InputVideoState: ...
    @property
    def audio(self) -> global___InputAudioState: ...
    room_id: builtins.str
    """ID of the current/previous room published to"""
    started_at: builtins.int
    ended_at: builtins.int
    resource_id: builtins.str
    @property
    def tracks(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[livekit_models_pb2.TrackInfo]: ...
    def __init__(
        self,
        *,
        status: global___IngressState.Status.ValueType = ...,
        error: builtins.str = ...,
        video: global___InputVideoState | None = ...,
        audio: global___InputAudioState | None = ...,
        room_id: builtins.str = ...,
        started_at: builtins.int = ...,
        ended_at: builtins.int = ...,
        resource_id: builtins.str = ...,
        tracks: collections.abc.Iterable[livekit_models_pb2.TrackInfo] | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["audio", b"audio", "video", b"video"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["audio", b"audio", "ended_at", b"ended_at", "error", b"error", "resource_id", b"resource_id", "room_id", b"room_id", "started_at", b"started_at", "status", b"status", "tracks", b"tracks", "video", b"video"]) -> None: ...

global___IngressState = IngressState

@typing_extensions.final
class InputVideoState(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MIME_TYPE_FIELD_NUMBER: builtins.int
    AVERAGE_BITRATE_FIELD_NUMBER: builtins.int
    WIDTH_FIELD_NUMBER: builtins.int
    HEIGHT_FIELD_NUMBER: builtins.int
    FRAMERATE_FIELD_NUMBER: builtins.int
    mime_type: builtins.str
    average_bitrate: builtins.int
    width: builtins.int
    height: builtins.int
    framerate: builtins.float
    def __init__(
        self,
        *,
        mime_type: builtins.str = ...,
        average_bitrate: builtins.int = ...,
        width: builtins.int = ...,
        height: builtins.int = ...,
        framerate: builtins.float = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["average_bitrate", b"average_bitrate", "framerate", b"framerate", "height", b"height", "mime_type", b"mime_type", "width", b"width"]) -> None: ...

global___InputVideoState = InputVideoState

@typing_extensions.final
class InputAudioState(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    MIME_TYPE_FIELD_NUMBER: builtins.int
    AVERAGE_BITRATE_FIELD_NUMBER: builtins.int
    CHANNELS_FIELD_NUMBER: builtins.int
    SAMPLE_RATE_FIELD_NUMBER: builtins.int
    mime_type: builtins.str
    average_bitrate: builtins.int
    channels: builtins.int
    sample_rate: builtins.int
    def __init__(
        self,
        *,
        mime_type: builtins.str = ...,
        average_bitrate: builtins.int = ...,
        channels: builtins.int = ...,
        sample_rate: builtins.int = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["average_bitrate", b"average_bitrate", "channels", b"channels", "mime_type", b"mime_type", "sample_rate", b"sample_rate"]) -> None: ...

global___InputAudioState = InputAudioState

@typing_extensions.final
class UpdateIngressRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INGRESS_ID_FIELD_NUMBER: builtins.int
    NAME_FIELD_NUMBER: builtins.int
    ROOM_NAME_FIELD_NUMBER: builtins.int
    PARTICIPANT_IDENTITY_FIELD_NUMBER: builtins.int
    PARTICIPANT_NAME_FIELD_NUMBER: builtins.int
    BYPASS_TRANSCODING_FIELD_NUMBER: builtins.int
    AUDIO_FIELD_NUMBER: builtins.int
    VIDEO_FIELD_NUMBER: builtins.int
    ingress_id: builtins.str
    name: builtins.str
    room_name: builtins.str
    participant_identity: builtins.str
    participant_name: builtins.str
    bypass_transcoding: builtins.bool
    @property
    def audio(self) -> global___IngressAudioOptions: ...
    @property
    def video(self) -> global___IngressVideoOptions: ...
    def __init__(
        self,
        *,
        ingress_id: builtins.str = ...,
        name: builtins.str = ...,
        room_name: builtins.str = ...,
        participant_identity: builtins.str = ...,
        participant_name: builtins.str = ...,
        bypass_transcoding: builtins.bool | None = ...,
        audio: global___IngressAudioOptions | None = ...,
        video: global___IngressVideoOptions | None = ...,
    ) -> None: ...
    def HasField(self, field_name: typing_extensions.Literal["_bypass_transcoding", b"_bypass_transcoding", "audio", b"audio", "bypass_transcoding", b"bypass_transcoding", "video", b"video"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing_extensions.Literal["_bypass_transcoding", b"_bypass_transcoding", "audio", b"audio", "bypass_transcoding", b"bypass_transcoding", "ingress_id", b"ingress_id", "name", b"name", "participant_identity", b"participant_identity", "participant_name", b"participant_name", "room_name", b"room_name", "video", b"video"]) -> None: ...
    def WhichOneof(self, oneof_group: typing_extensions.Literal["_bypass_transcoding", b"_bypass_transcoding"]) -> typing_extensions.Literal["bypass_transcoding"] | None: ...

global___UpdateIngressRequest = UpdateIngressRequest

@typing_extensions.final
class ListIngressRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ROOM_NAME_FIELD_NUMBER: builtins.int
    INGRESS_ID_FIELD_NUMBER: builtins.int
    room_name: builtins.str
    """when blank, lists all ingress endpoints
    (optional, filter by room name)
    """
    ingress_id: builtins.str
    """(optional, filter by ingress ID)"""
    def __init__(
        self,
        *,
        room_name: builtins.str = ...,
        ingress_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["ingress_id", b"ingress_id", "room_name", b"room_name"]) -> None: ...

global___ListIngressRequest = ListIngressRequest

@typing_extensions.final
class ListIngressResponse(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    ITEMS_FIELD_NUMBER: builtins.int
    @property
    def items(self) -> google.protobuf.internal.containers.RepeatedCompositeFieldContainer[global___IngressInfo]: ...
    def __init__(
        self,
        *,
        items: collections.abc.Iterable[global___IngressInfo] | None = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["items", b"items"]) -> None: ...

global___ListIngressResponse = ListIngressResponse

@typing_extensions.final
class DeleteIngressRequest(google.protobuf.message.Message):
    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    INGRESS_ID_FIELD_NUMBER: builtins.int
    ingress_id: builtins.str
    def __init__(
        self,
        *,
        ingress_id: builtins.str = ...,
    ) -> None: ...
    def ClearField(self, field_name: typing_extensions.Literal["ingress_id", b"ingress_id"]) -> None: ...

global___DeleteIngressRequest = DeleteIngressRequest
